% bildet aus Benutzereinstellungen die Figures, Frames und uicontrols und Graphiken

function make_gui()
global objekte

fenster=objekte.figures;
frames=objekte.frames;

if isfield(objekte,'ui')
    ui=objekte.ui;
else 
    ui='';
end
if isfield(objekte,'graph_line')
    graph_line=objekte.graph_line;
else 
    graph_line='';
end
if isfield(objekte,'graph_surf')
    graph_surf=objekte.graph_surf;
else 
    graph_surf='';
end
if isfield(objekte,'graph_contour')
    graph_contour=objekte.graph_contour;
else 
    graph_contour='';
end
if isfield(objekte,'graph_patch')
    graph_patch=objekte.graph_patch;
else 
    graph_patch='';
end
if isfield(objekte,'graph_image')
    graph_image=objekte.graph_image;
else 
    graph_image='';
end
if isfield(objekte,'texte')
    texte=objekte.texte;
else 
    texte='';
end

han=objekte.han;


%Figures erschaffen und Eigenschaften setzen
tic
for i=1:length(fenster)
    han(length(han)+1)=figure;
    default_values(han(end))
    felder=fieldnames(fenster(i));
    for j=1:length(felder)
        if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(fenster(i),char(felder(j))))
            set(han(end),char(felder(j)),getfield(fenster(i),char(felder(j))))
        else
            set_userdata(han(end),char(felder(j)),getfield(fenster(i),char(felder(j))))
        end
    end
    set_userdata(han(end),'figure',i);
    usdat=get(han(end),'userdata');
    
    if isfield(usdat,'colormap')
        
        if ~isempty(char(usdat.colormap))
            cm=char(usdat.colormap);
            switch cm
            case 'summer'
                colormap(summer)
            case 'autumn'
                colormap(autumn)
            case 'hsv'
                colormap(hsv)
            case 'jet'
                colormap(jet)
            case 'spring'
                colormap(spring)
            case 'copper'
                colormap(copper)
            case 'hot'
                colormap(hot)
            case 'cool'
                colormap(cool)
            case 'colorcube'
                colormap(colorcube)
            otherwise
                colormap(hsv)
            end
        end  
    end
    
end

%Frames (Achsen) erschaffen und Eigenschaften setzen
han_zahl=length(han);
korrektur=0;i2=1;
disp('figures')
toc
tic

for i=1:length(frames)
    h1(i)=getfield(frames(i),'figure');
    art=getfield(frames(i),'art');
    eltern=find_handle(han,'type','figure','figure',h1(i));
    
    switch art
    case 'achse'
        han(han_zahl+i)=axes('parent',eltern);
        axis 'off';
    case 'uicon'
        han(han_zahl+i)=uicontrol('style','frame','parent',eltern,'visible',frames(i).Visible_ui);
    end
    default_values(han(end))
    tag_ax=get(han(end),'Tag');
    
    setfield(frames(i),'parent',eltern);
    
    posi=getfield(frames(i),'Position');
    xl_gap=get_userdata(han(han_zahl+i),'xl_gap');
    xr_gap=get_userdata(han(han_zahl+i),'xr_gap');
    yu_gap=get_userdata(han(han_zahl+i),'yu_gap');
    yo_gap=get_userdata(han(han_zahl+i),'yo_gap');
    
    switch art
    case 'achse'
        posi_neu=[posi(1)+xl_gap*posi(3),posi(2)+yu_gap*posi(4),posi(3)*(1-xl_gap-xr_gap),posi(4)*(1-yu_gap-yo_gap)];  
    case 'uicon'
        posi_neu=posi;
        set(han(end),'tag',strcat('ui_',tag_ax));
    end
    
    frames(i)=setfield(frames(i),'Position',posi_neu);
    
    felder=fieldnames(frames(i));
    for j=1:length(felder)
        if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(frames(i),char(felder(j))))
            set(han(end),char(felder(j)),getfield(frames(i),char(felder(j))))            
        else
            set_userdata(han(end),char(felder(j)),getfield(frames(i),char(felder(j))))            
        end
    end
    set_userdata(han(end),'Position_alt',posi);
    
    switch art
    case 'uicon'
    case 'achse'
        set(han(end),'Position',posi_neu);
        usdat=get(han(end),'userdata');
        if isfield(usdat,'axis')
            for k=1:length(usdat.axis)
                if ~isempty(char(usdat.axis(k)))
                    axes(han(end))
                    axis(char(usdat.axis(k)))
                end
            end 
        end
        
    end
    if (i>1 & h1(i)~=h1(i-1))
        korrektur=korrektur+length(find(h1==h1(i-1)));
    end
    
    set_userdata(han(han_zahl+i),'frame',i-korrektur); 
    set_userdata(han(end),'figure',h1(i)); 
end

% %uicontrols in den Frames schaffen
disp('axes')
toc
tic
for i=1:length(ui)
    
    h1=getfield(ui(i).teile(1),'figure');
    h2=getfield(ui(i).teile(1),'frame');
    
    eltern=find_handle(han,'type','uicontrol','figure',h1,'frame',h2);
    eltern2=find_handle(han,'type','figure','figure',h1);
    %     %Matrix auswerten
    pos=get_userdata(eltern,'Position_alt');
    [x_size,y_size]=size(ui(i).teile(1).matrix);
    [x,y]=meshgrid(linspace(pos(1),pos(1)+pos(3),y_size+1),linspace(pos(2),pos(2)+pos(4),x_size+1));
    for k=1:y_size
        for j=1:x_size
            pos_xanf(j,k)=x(j,k);
            pos_xend(j,k)=x(j,k+1);
            pos_yanf(j,k)=y(j,k);
            pos_yend(j,k)=y(j+1,k);
        end
    end
    for k=1:max(ui(i).teile(1).matrix(:));
        han(length(han)+1)=uicontrol;
        default_values(han(end));
        
        if isfield(ui(i).teile(k),'xl_gap') & ~isempty(ui(i).teile(k).xl_gap); xl_gap=ui(i).teile(k).xl_gap; 
        else xl_gap=get_userdata(han(end),'xl_gap'); end
        if isfield(ui(i).teile(k),'xr_gap') & ~isempty(ui(i).teile(k).xr_gap); xr_gap=ui(i).teile(k).xr_gap; 
        else xr_gap=get_userdata(han(end),'xr_gap'); end
        if isfield(ui(i).teile(k),'yu_gap') & ~isempty(ui(i).teile(k).yu_gap); yu_gap=ui(i).teile(k).yu_gap;
        else yu_gap=get_userdata(han(end),'yu_gap'); end
        if isfield(ui(i).teile(k),'yo_gap') & ~isempty(ui(i).teile(k).yo_gap); yo_gap=ui(i).teile(k).yo_gap; 
        else yo_gap=get_userdata(han(end),'yo_gap'); end        
        
        matrix=flipud(ui(i).teile(1).matrix);
        min_x=min(pos_xanf(find(matrix==k)));
        min_y=min(pos_yanf(find(matrix==k)));
        max_x=max(pos_xend(find(matrix==k)));
        max_y=max(pos_yend(find(matrix==k)));
        
        dx=max_x-min_x;
        dy=max_y-min_y;   
        dxl_lag=(x(1,2)-x(1,1))*xl_gap;
        dyu_lag=(y(2,1)-y(1,1))*yo_gap;
        dxr_lag=(x(1,2)-x(1,1))*xr_gap;
        dyo_lag=(y(2,1)-y(1,1))*yu_gap;
        delta_x=dx-(dxl_lag+dxr_lag);
        delta_y=dy-(dyo_lag+dyu_lag);
        pos_ui=[min_x+dxl_lag,min_y+dyo_lag,delta_x,delta_y];
        ui(i).teile(k).Position=pos_ui;
        ui(i).teile(k).Parent=eltern2;
        ursprung_style=ui(i).teile(k).Style;
        ui(i).teile(k).ursprung_style=ursprung_style;
        
        felder=fieldnames(ui(i).teile(k));
        
        for j=1:length(felder)
            if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(ui(i).teile(k),char(felder(j))))
                set(han(end),char(felder(j)),getfield(ui(i).teile(k),char(felder(j))))            
            else
                set_userdata(han(end),char(felder(j)),getfield(ui(i).teile(k),char(felder(j))))            
            end
        end
        
        if isfield(ui(i).teile(k),'string2')
            str2=ui(i).teile(k).string2;
            if ~isempty(str2)
                callb_alt=get(han(end),'callback');
                if isempty(callb_alt)
                    callb='change_string;';
                else
                    callb=['change_string;' callb_alt];
                end
                set(han(end),'Callback',callb);
            end
        end
        %         
        %         
        add_text=get_userdata(han(end),'add_text');
        add_edit=get_userdata(han(end),'add_edit');
        add_summe=add_text+add_edit;
        %         
        if (add_summe) > 0 
            switch add_summe
            case 1  % nur ein Textfeld hinzufgen
                han(length(han)+1)=uicontrol;
                default_values(han(end))
                set(han(end-1),'position',[pos_ui(1),min_y+dyu_lag/2,pos_ui(3),dy/2-5*dyo_lag/6])
                for j=1:length(felder)
                    if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(ui(i).teile(k),char(felder(j))))
                        set(han(end),char(felder(j)),getfield(ui(i).teile(k),char(felder(j))))            
                    else
                        set_userdata(han(end),char(felder(j)),getfield(ui(i).teile(k),char(felder(j))))            
                    end
                end
                set(han(end),'style','text','position',[pos_ui(1),min_y+dyu_lag/6+dy/2,pos_ui(3),dy/2-5*dyo_lag/6])
                t=get(han(end),'tag');
                set(han(end),'tag',[t,'_text'])
                faktor=0;
            case 2  % Textfeld und Editfeld hinzufgen
                
                han(length(han)+1)=uicontrol;
                default_values(han(end))
                han(length(han)+1)=uicontrol;
                default_values(han(end))                
                set(han(end-2),'position',[pos_ui(1),min_y+dyu_lag/2,pos_ui(3),dy/2-5*dyo_lag/6])
                for j=1:length(felder)
                    if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(ui(i).teile(k),char(felder(j))))
                        set(han(end-1),char(felder(j)),getfield(ui(i).teile(k),char(felder(j))))
                        set(han(end),char(felder(j)),getfield(ui(i).teile(k),char(felder(j))))                        
                    else
                        set_userdata(han(end-1),char(felder(j)),getfield(ui(i).teile(k),char(felder(j))))
                        set_userdata(han(end),char(felder(j)),getfield(ui(i).teile(k),char(felder(j))))            
                    end
                end
                callb_alt=get(han(end-2),'callback');
                if isempty(callb_alt)
                    callb='setup_slider_edit;';
                else
                    callb=['setup_slider_edit;' callb_alt];
                end
                string_value=num2str(get(han(end-2),'value'));
                set(han(end-2),'callback',callb)
                set(han(end-1),'style','text','position',[pos_ui(1)+0.35*delta_x,min_y+dyu_lag/6+dy/2,2*delta_x/3,dy/2-5*dyo_lag/6],...
                    'horizontalalignment','center')  
                set(han(end),'style','edit','position',[pos_ui(1),min_y+dyu_lag/6+dy/2,0.3*delta_x,dy/2-5*dyo_lag/6],...
                    'horizontalalignment','center','string',string_value,'callback',callb,'backgroundcolor',[1,1,1]) 
                min_val=get(han(end-2),'Min');
                max_val=get(han(end-2),'Max');
                set_userdata(han(end),'min_val',min_val);
                set_userdata(han(end),'max_val',max_val);
                faktor=1;
                t=get(han(end-2),'tag');
                set(han(end-1),'tag',[t,'_text'])
                set(han(end),'tag',[t,'_edit'])
            end
            if isfield(get(han(end-faktor),'userdata'),'text_string')
                text_string=get_userdata(han(end-faktor),'text_string');
                if ~isempty(text_string)
                    set(han(end-faktor),'string',text_string)
                end
                set_userdata(han(end-faktor),'original','nein')
            end
            
        end
        if add_summe<2
            if strcmp(get(han(end-add_summe),'style'),'edit')
                callb_alt=get(han(end-add_summe),'callback');
                if isempty(callb_alt)
                    callb='setup_slider_edit;';
                else
                    callb=['setup_slider_edit;' callb_alt];
                end        
                set(han(end-add_summe),'callback',callb)
            end
        end
    end
    clear pos_xanf pos_xend pos_yanf pos_yend
end
disp('ui')
toc
tic
for i=1:length(graph_line)
    
    fig_num=getfield(graph_line(i),'figure');   
    frame_num=getfield(graph_line(i),'frame');
    h1=find_handle(han,'type','axes','frame',frame_num,'figure',fig_num);    
    axes(h1);
    han(length(han)+1)=line;
    default_values(han(end))
    felder=fieldnames(graph_line(i));
    
    for j=1:length(felder)
        if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(graph_line(i),char(felder(j))))
            set(han(end),char(felder(j)),getfield(graph_line(i),char(felder(j))))
        else
            set_userdata(han(end),char(felder(j)),getfield(graph_line(i),char(felder(j))))
        end
    end    
    usdat=get(han(end),'userdata');
    if isfield(usdat,'axis')
        for k=1:length(usdat.axis)
            if ~isempty(char(usdat.axis(k)))
                axis(char(usdat.axis(k)))
            end
        end 
    end
end
disp('lines')
toc
tic
for i=1:length(graph_surf)
    %     
    fig_num=getfield(graph_surf(i),'figure');   
    frame_num=getfield(graph_surf(i),'frame');
    h1=find_handle(han,'type','axes','frame',frame_num,'figure',fig_num);     
    
    axes(h1);      
    h1_usdat=get(h1,'userdata');
    if isfield(graph_surf(i),'stil')
        h3=graph_surf(i).stil;
        if strcmp(h3,'mesh')
            han(length(han)+1)=mesh([]);
        else
            
            han(length(han)+1)=surface('xdata',[],'ydata',[],'zdata',[],'cdata',[]);
            
        end
    else
        han(length(han)+1)=surface('xdata',[],'ydata',[],'zdata',[],'cdata',[]);
    end
    %     
    default_values(han(end))
    felder=fieldnames(graph_surf(i));
    %     
    for j=1:length(felder)
        if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(graph_surf(i),char(felder(j))))
            set(han(end),char(felder(j)),getfield(graph_surf(i),char(felder(j))))
        else
            set_userdata(han(end),char(felder(j)),getfield(graph_surf(i),char(felder(j))))
        end
    end    
    usdat=get(han(end),'userdata');
    if isfield(usdat,'axis')
        for k=1:length(usdat.axis)
            if ~isempty(char(usdat.axis(k)))
                axis(char(usdat.axis(k)))
            end
        end 
    end
    if isfield(usdat,'shading')
        
        if ~isempty(char(usdat.shading))
            sh=char(usdat.shading);
            switch sh
            case 'interp'
                shading interp
            case 'faceted'
                shading faceted
            case 'flat'
                shading flat
            otherwise
                shading faceted
            end
        end       
    end
    set(h1,'userdata',h1_usdat);
end
disp('surf')
toc
tic
for i=1:length(texte)
    h1=getfield(texte(i),'figure');
    h2=getfield(texte(i),'frame');
    eltern=find_handle(han,'type','axes','frame',h2,'figure',h1);     
    
    h3=texte(i).typ;
    axes(eltern)
    
    switch h3
    case 'xlabel'
        han(length(han)+1)=xlabel('');
    case 'ylabel'
        han(length(han)+1)=ylabel('');
    case 'zlabel'
        han(length(han)+1)=zlabel('');        
    case 'title'
        han(length(han)+1)=title('');
    otherwise
        han(length(han)+1)=text('');
    end
    
    default_values(han(end));
    
    felder=fieldnames(texte(i));
    
    for j=1:length(felder)
        if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(texte(i),char(felder(j))))
            set(han(end),char(felder(j)),getfield(texte(i),char(felder(j))))
        else
            set_userdata(han(end),char(felder(j)),getfield(texte(i),char(felder(j))))
        end
    end    
end
disp('texte')
toc
tic
for i=1:length(graph_contour)
    fig_num=getfield(graph_contour(i),'figure');   
    frame_num=getfield(graph_contour(i),'frame');   
    h1=find_handle(han,'type','axes','frame',frame_num,'figure',fig_num);
    axes(h1);      
    
    if isfield(graph_contour(i),'line_num')
        line_num=graph_contour(i).line_num;
    else
        line_num=10;    
    end
    
    for k=1:line_num
        han(length(han)+1)=line;
        default_values(han(end))
        felder=fieldnames(graph_contour(i));
        
        for j=1:length(felder)
            if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(graph_contour(i),char(felder(j))))
                set(han(end),char(felder(j)),getfield(graph_contour(i),char(felder(j))))
            else
                set_userdata(han(end),char(felder(j)),getfield(graph_contour(i),char(felder(j))))
            end
        end   
        set_userdata(han(end),'nummer',strcat('cont',num2str(k)));
    end
end
disp('contours')
toc
tic
for i=1:length(graph_patch)
    fig_num=getfield(graph_patch(i),'figure');   
    frame_num=getfield(graph_patch(i),'frame');   
    h1=find_handle(han,'type','axes','frame',frame_num,'figure',fig_num);
    axes(h1);      
    
    if isfield(graph_patch(i),'bin_num')
        bin_num=graph_patch(i).bin_num;
    else
        bin_num=10;    
    end
    
    for k=1:bin_num
        han(length(han)+1)=patch;
        default_values(han(end))
        felder=fieldnames(graph_patch(i));
        
        for j=1:length(felder)
            if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(graph_patch(i),char(felder(j))))
                set(han(end),char(felder(j)),getfield(graph_patch(i),char(felder(j))))
            else
                set_userdata(han(end),char(felder(j)),getfield(graph_patch(i),char(felder(j))))
            end
        end   
        set_userdata(han(end),'nummer',strcat('bin',num2str(k)));
    end
end
disp('bar')
toc
tic
for i=1:length(graph_image)
    fig_num=getfield(graph_image(i),'figure');   
    frame_num=getfield(graph_image(i),'frame');
    h1=find_handle(han,'type','axes','frame',frame_num,'figure',fig_num);
    axes(h1);
    han(length(han)+1)=image;
    default_values(han(end))
    felder=fieldnames(graph_image(i));
    
    for j=1:length(felder)
        if isfield(get(han(end)),char(felder(j))) & ~isempty(getfield(graph_image(i),char(felder(j))))
            set(han(end),char(felder(j)),getfield(graph_image(i),char(felder(j))))
        else
            set_userdata(han(end),char(felder(j)),getfield(graph_image(i),char(felder(j))))
        end
    end    
    usdat=get(han(end),'userdata');
    if isfield(usdat,'axis')
        for k=1:length(usdat.axis)
            if ~isempty(char(usdat.axis(k)))
                axis(char(usdat.axis(k)))
            end
        end 
    end
    
    
end
disp('images')
toc

% for i=1:length(frames)
%     set(han(axen_zahl+i),'Tag',getfield(frames(i),'Tag'))
% end

% stop_han=find_handle(han,'type','uicontrol','Tag','stop');
% pause_han=find_handle(han,'type','uicontrol','Tag','pause');
% if ~isempty(stop_han)
%     variable.stop=get(stop_han,'value');
% end
% if ~isempty(pause_han)
%     variable.pause=get(pause_han,'value');
% end
% 
% 
%objekte=setfield(objekte,'variable',variable);

objekte=setfield(objekte,'han',han);