% berechnet die Poincare Schnitte, Teilchenbahn, Daten werden aus graphischer Oberflche geholt

function poincare_main
global objekte

% Daten werden aus dem Graphikfenster abgefragt
[x0,y0,vx0,vy0,perioden,perioden_schritte,rel_genauigkeit,abs_genauigkeit,diff_solver]=...
    get_value({'x0','y0','vx0','vy0','perioden','perioden_schritte','rel_gen','abs_gen','diff_solver'});

rel_genauigkeit=1*10^-(rel_genauigkeit);
abs_genauigkeit=1*10^-(abs_genauigkeit);

y0=[x0,y0,vx0,vy0];

op = odeset('AbsTol',abs_genauigkeit,'RelTol',rel_genauigkeit,'NormControl','on');
op = odeset(op,'Jacobian',@jforce);
op = odeset(op,'Events',@eforce);

tspan=linspace(0,2*pi*perioden,perioden*perioden_schritte);
switch diff_solver
case 1
    [t,y,te,ye,ie] = ode23(@force,tspan,y0,op);
case 2
    [t,y,te,ye,ie] = ode45(@force,tspan,y0,op);
case 3
    [t,y,te,ye,ie] = ode113(@force,tspan,y0,op);
case 4
    [t,y,te,ye,ie] = ode15s(@force,tspan,y0,op);
case 5
    [t,y,te,ye,ie] = ode23s(@force,tspan,y0,op);
case 6
    [t,y,te,ye,ie] = ode23t(@force,tspan,y0,op);
case 7
    [t,y,te,ye,ie] = ode23tb(@force,tspan,y0,op);
case 8
end

%Rckrechnung

y1=y(end,:);
y1(3:4) = -y1(3:4);

op = odeset('AbsTol',abs_genauigkeit,'RelTol',rel_genauigkeit,'NormControl','on');
op = odeset(op,'Jacobian',@jforce);

switch diff_solver
case 1
    [t2,y2] = ode23(@force,tspan,y1,op);
case 2
    [t2,y2]= ode45(@force,tspan,y1,op);
case 3
    [t2,y2] = ode113(@force,tspan,y1,op);
case 4
    [t2,y2] = ode15s(@force,tspan,y1,op);
case 5
    [t2,y2] = ode23s(@force,tspan,y1,op);
case 6
    [t2,y2] = ode23t(@force,tspan,y1,op);
case 7
    [t2,y2] = ode23tb(@force,tspan,y1,op);
case 8
end


y00 = y2(end,:);
y00(3:4) = -y00(3:4);

%alle relevanten Variablen werden der Hauptstruktur bergeben
objekte.variable=struct('y0',y0,'ry0',y00,'t',t,'y',y,'te',te,'ye',ye,'ie',ie);

%eigentliche Differentialgleichung
function yp=force(t,y)

yp = zeros(size(y));
yp(1) = y(3);
yp(2) = y(4);
yp(3) = -y(1) - 2*y(1)*y(2);
yp(4) = -y(2) + y(2)^2 - y(1)^2;



%gibt Ereignisse wie Nullstellen zurck
function [val,it,dir] = eforce(t,y)

val = zeros(1,2);
it = val;
dir = val;

val(1) = y(1);
val(2) = y(2);

%Jacobi
function j = jforce(t,y)

j = zeros(4);
j(1,3) = 1;
j(2,4) = 1;
j(3,1) = -2*(1+y(2));
j(3,2) = -2*y(1);
j(4,1) = -2*y(1);
j(4,2) = 2*y(2)-1;

